﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace example
{
    public partial class Form1 : Form
    {
        /////////////////////////////////////////////////////////////////////////////
        const int IMAGE_FORMAT_JPG = 1;
        const int IMAGE_FORMAT_JP2 = 2;
        const int IMAGE_FORMAT_JPC = 3;

        /////////////////////////////////////////////////////////////////////////////        
        const int JPEG_PROGRESSIVE = 1;     //Progressive JPEG
        const int JPEG_BASELINE = 2;        //Baseline JPEG
        const int JPEG_OPT_BASELINE = 3;    //Optimized baseline JPEG
        

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string inFile;
            string outPath;
            int id;
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);

            inFile = appPath + "\\test.pdf";
            outPath = appPath + "\\output\\";

            id = axPdftojpeg.XLoad(inFile, "");
            if (id == -1)
            {
                MessageBox.Show("PDF file unexist or damaged!");
                return;
            }
            if (id == -2)
            {
                MessageBox.Show("PDF file is restricted!");
                return;
            }

            axPdftojpeg.XSetParam(id, outPath, IMAGE_FORMAT_JPG, 24, JPEG_PROGRESSIVE, 75, 0, 0, 0, 0, 0, 96, 96);

            int fsize = 16;
            int fcolor = 255;//red
            int isbold = 0;
            int isitalic = 1;
            int isunderline = 1;
            int position = 2;//Top-Center
            int xoff = 0;
            int yoff = 0;
            axPdftojpeg.XSetWatermark(id, "Watermark", "Arial", fsize, fcolor, isbold, isitalic, isunderline, position, xoff, yoff);

            int pageCount = axPdftojpeg.XGetCount(id);
            int pageWidth = 0;
            int pageHeight = 0;
            for (int i = 1; i <= pageCount; i++)
            {
                pageWidth = axPdftojpeg.XGetWidth(id, i);
                pageHeight = axPdftojpeg.XGetHeight(id, i);

                axPdftojpeg.XEncode(id, i);
                progressBar1.Value = i * 100 / pageCount;
            }
            axPdftojpeg.XFree(id);

            MessageBox.Show("Convert finished!");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string inFile;
            string outPath;
            int id;
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);

            inFile = appPath + "\\test.pdf";
            outPath = appPath + "\\output\\";

            id = axPdftojpeg.XLoad(inFile, "");
            if (id == -1)
            {
                MessageBox.Show("PDF file unexist or damaged!");
                return;
            }
            if (id == -2)
            {
                MessageBox.Show("PDF file is restricted!");
                return;
            }

            axPdftojpeg.XSetParam(id, outPath, IMAGE_FORMAT_JP2, 24, 0, 75, 0, 0, 90, 800, 600, 120, 120);

            int pageCount = axPdftojpeg.XGetCount(id);
            for (int i = 1; i <= pageCount; i++)
            {
                string fname = "new_name" + i;
                axPdftojpeg.XEncodeEx(id, i, fname);
                progressBar1.Value = i * 100 / pageCount;
            }
            axPdftojpeg.XFree(id);

            MessageBox.Show("Convert finished!");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);
            string inFile = appPath + "\\test.pdf";
            string outFile = appPath + "\\output.txt";

            int txtmode = 1;//1,2
            int pagebreak = 1;//0,1

            axPdftojpeg.XExtractText(inFile, "password", outFile, txtmode, pagebreak);

            MessageBox.Show("Convert finished!");
        }
    }
}
