// exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "example.h"
#include "exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog

CExampleDlg::CExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExampleDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_progress);
	DDX_Control(pDX, IDC_PDFTOJPEGCTRL1, m_pdftojpeg_ocx);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg message handlers

BOOL CExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton1() 
{
	char infile[256],outpath[256];
	GetModulePath(infile,"test.pdf");
	GetModulePath(outpath,"outpath\\");

	long id = m_pdftojpeg_ocx.XLoad(infile,NULL);
	if(id==-1){
		MessageBox("PDF file unexist or damaged!");
		return;
	}
	if(id==-2){
		MessageBox("PDF file is restricted!");
		return;
	}

	m_pdftojpeg_ocx.XSetParam(id,outpath,IMAGE_FORMAT_JPG,24,JPEG_PROGRESSIVE,75,0,0,0,0,0,96,96);

	long fsize = 16;
	long fcolor = 255;//red
	long isbold = 0;
	long isitalic = 1;
	long isunderline = 1;
	long position = 2;//Top-Center
	long xoff = 0;
	long yoff = 0;
	m_pdftojpeg_ocx.XSetWatermark(id,"Watermark","Arial",fsize,fcolor,isbold,isitalic,isunderline,position,xoff,yoff);

	long pageCount = m_pdftojpeg_ocx.XGetCount(id);
	long pageWidth = 0;
	long pageHeight = 0;
	for(long i=1; i<=pageCount; i++){
		pageWidth = m_pdftojpeg_ocx.XGetWidth(id,i);
		pageHeight = m_pdftojpeg_ocx.XGetHeight(id,i);

		m_pdftojpeg_ocx.XEncode(id,i);
		m_progress.SetPos( i*100/pageCount );
	}
	m_pdftojpeg_ocx.XFree(id);

	MessageBox("Convert finished!");	
}
////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton2() 
{
	char infile[256],outpath[256];
	GetModulePath(infile,"test.pdf");
	GetModulePath(outpath,"outpath\\");

	long id = m_pdftojpeg_ocx.XLoad(infile,NULL);	
	if(id==-1){
		MessageBox("PDF file unexist or damaged!");
		return;
	}
	if(id==-2){
		MessageBox("PDF file is restricted!");
		return;
	}

	m_pdftojpeg_ocx.XSetParam(id,outpath,IMAGE_FORMAT_JP2,24,0,75,0,0,90,800,600,120,120);

	char fname[256];
	long pageCount = m_pdftojpeg_ocx.XGetCount(id);
	for(long i=1; i<=pageCount; i++){
		sprintf(fname,"new_name%02d",i);
		m_pdftojpeg_ocx.XEncodeEx(id,i,fname);
		m_progress.SetPos( i*100/pageCount );
	}
	m_pdftojpeg_ocx.XFree(id);

	MessageBox("Convert finished!");	
}

void CExampleDlg::OnButton3() 
{
	char infile[256],outfile[256];
	GetModulePath(infile,"test.pdf");
	GetModulePath(outfile,"output.txt");

	long txtmode=1;//1,2
	long pagebreak=1;//0,1
	m_pdftojpeg_ocx.XExtractText(infile,"password",outfile,txtmode,pagebreak);

	MessageBox("Convert finished!");		
}
