﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace example
{
    public partial class Form1 : Form
    {
        /////////////////////////////////////////////////////////////////////////////
        [DllImport("pdftojpeg", CallingConvention = CallingConvention.StdCall)]
        public static extern int MLoad(string filename,string password);

        [DllImport("pdftojpeg", CallingConvention = CallingConvention.StdCall)]
        public static extern int MEncode(int id,int pageno);

        [DllImport("pdftojpeg.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MEncodeEx(int id, int pageno, string fname);

        [DllImport("pdftojpeg.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MFree(int id);

        [DllImport("pdftojpeg.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MGetCount(int id);

        [DllImport("pdftojpeg.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MSetParam(int id, string outpath, int imagetype, int bitcount,
                                          int mode, int quality, int grayscale, int other,
                                          int rotate, int width, int height, int xdpi, int ydpi);

        [DllImport("pdftojpeg.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MGetWidth(int id, int pageno);

        [DllImport("pdftojpeg.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MGetHeight(int id, int pageno);

        [DllImport("pdftojpeg.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MSetWatermark(int id, string text, string fontname, int fontsize, int fontcolor,
                                                int isbold, int isitalic, int isunderline, int position, int xoff, int yoff);

        [DllImport("pdftojpeg", CallingConvention = CallingConvention.StdCall)]
        public static extern int MExtractText(string infile, string password, string outfile, int mode, int pagebreak);
        
        /////////////////////////////////////////////////////////////////////////////
        const int IMAGE_FORMAT_JPG = 1;
        const int IMAGE_FORMAT_JP2 = 2;
        const int IMAGE_FORMAT_JPC = 3;

        /////////////////////////////////////////////////////////////////////////////        
        const int JPEG_PROGRESSIVE = 1;     //Progressive JPEG
        const int JPEG_BASELINE = 2;        //Baseline JPEG
        const int JPEG_OPT_BASELINE = 3;    //Optimized baseline JPEG
       
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);
            string inFile = appPath + "\\test.pdf";
            string outPath = appPath + "\\output\\";

            int id = MLoad(inFile, "");
            if (id == -1)
            {
                MessageBox.Show("PDF file unexist or damaged!");
                return;
            }
            if (id == -2)
            {
                MessageBox.Show("PDF file is restricted!");
                return;
            }

            MSetParam(id, outPath, IMAGE_FORMAT_JPG, 24, JPEG_PROGRESSIVE, 75, 0, 0, 0, 0, 0, 96, 96);

            int fsize = 16;
            int fcolor = 255;//red
            int isbold = 0;
            int isitalic = 1;
            int isunderline = 1;
            int position = 2;//Top-Center
            int xoff = 0;
            int yoff = 0;
            MSetWatermark(id, "Watermark", "Arial", fsize, fcolor, isbold, isitalic, isunderline, position, xoff, yoff);

            int pageCount = MGetCount(id);
            int pageWidth = 0;
            int pageHeight = 0;
            for (int i = 1; i <= pageCount; i++)
            {
                pageWidth = MGetWidth(id, i);
                pageHeight = MGetHeight(id, i); 

                MEncode(id, i);
                progressBar1.Value = i * 100 / pageCount;
            }
            MFree(id);

            MessageBox.Show("Convert finished!");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);
            string inFile = appPath + "\\test.pdf";
            string outPath = appPath + "\\output\\";

            int id = MLoad(inFile, "");
            if (id == -1)
            {
                MessageBox.Show("PDF file unexist or damaged!");
                return;
            }
            if (id == -2)
            {
                MessageBox.Show("PDF file is restricted!");
                return;
            }

            MSetParam(id, outPath, IMAGE_FORMAT_JP2, 24, 0, 75, 0, 0, 90, 800, 600, 120, 120);

            int pageCount = MGetCount(id);
            for (int i = 1; i <= pageCount; i++)
            {
                string fname = "new_name" + i;
                MEncodeEx(id, i, fname);
                progressBar1.Value = i * 100 / pageCount;
            }
            MFree(id);

            MessageBox.Show("Convert finished!");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);
            string inFile = appPath + "\\test.pdf";
            string outFile = appPath + "\\output.txt";

            int txtmode = 1;//1,2
            int pagebreak = 1;//0,1

            MExtractText(inFile, "password", outFile, txtmode, pagebreak);

            MessageBox.Show("Convert finished!");
        }
    }
}
