//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "stdio.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadPdfToJpegDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"pdftojpeg.dll");	

	m_hinstLib = LoadLibrary(path);	
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pLoad = (MLoad *)GetProcAddress(m_hinstLib, "MLoad");
	if( pLoad == NULL ){ 
		FreePdfToJpegDll(); 
		return FALSE;
	}
	pEncode = (MEncode *)GetProcAddress(m_hinstLib, "MEncode");
	if( pEncode == NULL ){
		FreePdfToJpegDll();
		return FALSE;
	}
	pEncodeEx = (MEncodeEx *)GetProcAddress(m_hinstLib, "MEncodeEx");
	if( pEncodeEx == NULL ){
		FreePdfToJpegDll();
		return FALSE;
	}    
	pFree = (MFree *)GetProcAddress(m_hinstLib, "MFree");
	if( pFree == NULL ){
		FreePdfToJpegDll();
		return FALSE;
	}
	pGetCount = (MGetCount *)GetProcAddress(m_hinstLib, "MGetCount");
	if( pGetCount == NULL ){
		FreePdfToJpegDll();
		return FALSE;
	}
	pSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pSetParam == NULL ){ 
		FreePdfToJpegDll(); 
		return FALSE;
	}
	pMGetWidth = (MGetWidth *)GetProcAddress(m_hinstLib, "MGetWidth");
	if( pMGetWidth == NULL ){ 
		FreePdfToJpegDll();
		return FALSE;
	}
	pMGetHeight = (MGetHeight *)GetProcAddress(m_hinstLib, "MGetHeight");
	if( pMGetHeight == NULL ){ 
		FreePdfToJpegDll(); 
		return FALSE;
	}
	pSetWatermark = (MSetWatermark *)GetProcAddress(m_hinstLib, "MSetWatermark");
	if( pSetWatermark == NULL ){ 
		FreePdfToJpegDll(); 
		return FALSE;
	}
	pExtractText = (MExtractText *)GetProcAddress(m_hinstLib, "MExtractText");
	if( pExtractText == NULL ){ 
		FreePdfToJpegDll(); 
		return FALSE;
	}

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
BOOL TForm1::FreePdfToJpegDll()
{
    if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadPdfToJpegDll() == FALSE ){
        ShowMessage("Load pdftojpeg.dll failed!");
		return;
	}

	char infile[256],outpath[256];
	GetModulePath(infile,"test.pdf");
	GetModulePath(outpath,"outpath\\");

	long id = pLoad(infile,NULL);
	if(id==-1){
        ShowMessage("PDF file unexist or damaged!");
		FreePdfToJpegDll();
		return;
	}
	if(id==-2){
        ShowMessage("PDF file is restricted!");
		FreePdfToJpegDll();
		return;
	}

	pSetParam(id,outpath,IMAGE_FORMAT_JPG,24,JPEG_PROGRESSIVE,75,0,0,0,0,0,96,96);

 	long fsize = 16;
	long fcolor = 255;//red
	long isbold = 0;
	long isitalic = 1;
	long isunderline = 1;
	long position = 2;//Top-Center
	long xoff = 0;
	long yoff = 0;
	pSetWatermark(id,"Watermark","Arial",fsize,fcolor,isbold,isitalic,isunderline,position,xoff,yoff);

	long pageCount = pGetCount(id);
	long pageWidth = 0;
	long pageHeight = 0;
	for(long i=1; i<=pageCount; i++){
		pageWidth = pMGetWidth(id,i);
		pageHeight = pMGetHeight(id,i);

		pEncode(id,i);
		ProgressBar1->Position = i*100/pageCount;
	}
	pFree(id);

	FreePdfToJpegDll();
    ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadPdfToJpegDll() == FALSE ){
        ShowMessage("Load pdftojpeg.dll failed");
		return;
	}

	char infile[256],outpath[256];
	GetModulePath(infile,"test.pdf");
	GetModulePath(outpath,"outpath\\");

	long id = pLoad(infile,NULL);
	if(id==-1){
        ShowMessage("PDF file unexist or damaged!");
		FreePdfToJpegDll();
		return;
	}
	if(id==-2){
        ShowMessage("PDF file is restricted!");
		FreePdfToJpegDll();
		return;
	}

	pSetParam(id,outpath,IMAGE_FORMAT_JP2,24,0,75,0,0,90,800,600,120,120);

    char fname[256];
	long pageCount = pGetCount(id);
	for(long i=1; i<=pageCount; i++){
		sprintf(fname,"new_name%02d",i);
		pEncodeEx(id,i,fname);
		ProgressBar1->Position = i*100/pageCount;
	}
	pFree(id);

	FreePdfToJpegDll();
    ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	if( LoadPdfToJpegDll() == FALSE ){
        ShowMessage("Load pdftojpeg.dll failed");
		return;
	}

	char infile[256],outfile[256];
	GetModulePath(infile,"test.pdf");
	GetModulePath(outfile,"output.txt");

	long txtmode=1;//1,2
	long pagebreak=1;//0,1
	pExtractText(infile,"password",outfile,txtmode,pagebreak);

	FreePdfToJpegDll();
    ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------

