﻿Public Class Form1
    Private Declare Function MLoad Lib "pdftojpeg.dll" (ByVal filename As String, ByVal password As String) As Integer
    Private Declare Function MEncode Lib "pdftojpeg.dll" (ByVal id As Integer, ByVal pageno As Integer) As Integer
    Private Declare Function MEncodeEx Lib "pdftojpeg.dll" (ByVal id As Integer, ByVal pageno As Integer, ByVal fname As String) As Integer
    Private Declare Function MFree Lib "pdftojpeg.dll" (ByVal id As Integer) As Integer
    Private Declare Function MGetCount Lib "pdftojpeg.dll" (ByVal id As Integer) As Integer

    Private Declare Function MSetParam Lib "pdftojpeg.dll" (ByVal id As Integer, ByVal outpath As String, ByVal imagetype As Integer, _
                                                                ByVal bitcount As Integer, ByVal mode As Integer, ByVal quality As Integer, ByVal grayscale As Integer, ByVal other As Integer, _
                                                                ByVal rotate As Integer, ByVal width As Integer, ByVal height As Integer, ByVal xdpi As Integer, ByVal ydpi As Integer) As Integer

    Private Declare Function MGetWidth Lib "pdftojpeg.dll" (ByVal id As Integer, ByVal pageno As Integer) As Integer
    Private Declare Function MGetHeight Lib "pdftojpeg.dll" (ByVal id As Integer, ByVal pageno As Integer) As Integer

    Private Declare Function MSetWatermark Lib "pdftojpeg.dll" (ByVal id As Integer, ByVal text As String, ByVal fontname As String, ByVal fontsize As Integer, ByVal fontcolor As Integer, _
                                                                ByVal isbold As Integer, ByVal isitalic As Integer, ByVal isunderline As Integer, ByVal position As Integer, _
                                                                ByVal xoff As Integer, ByVal yoff As Integer) As Integer
    Private Declare Function MExtractText Lib "pdftojpeg.dll" (ByVal infile As String, ByVal password As String, ByVal outfile As String, ByVal mode As Integer, ByVal pagebreak As Integer) As Integer

    'Image formats
    Const IMAGE_FORMAT_JPG = 1
    Const IMAGE_FORMAT_JP2 = 2
    Const IMAGE_FORMAT_JPC = 3

    'JPEG Mode
    Const JPEG_PROGRESSIVE = 1  'Progressive JPEG
    Const JPEG_BASELINE = 2     'Baseline JPEG
    Const JPEG_OPT_BASELINE = 3 'Optimized baseline JPEG

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Dim id As Integer
        Dim pageCount As Integer
        Dim i As Integer
        Dim pageWidth As Integer
        Dim pageHeight As Integer

        Dim fsize As Integer
        Dim fcolor As Integer
        Dim isbold As Integer
        Dim isitalic As Integer
        Dim isunderline As Integer
        Dim position As Integer

        Dim inFile As String = Application.StartupPath + "\test.pdf"
        Dim outPath As String = Application.StartupPath + "\output\"

        id = MLoad(inFile, "")
        Select Case id
            Case -1
                MsgBox("PDF file unexist or damaged!")
                Exit Sub
            Case -2
                MsgBox("PDF file is restricted!")
                Exit Sub
        End Select

        MSetParam(id, outPath, IMAGE_FORMAT_JPG, 24, JPEG_PROGRESSIVE, 75, 0, 0, 0, 0, 0, 96, 96)

        fsize = 16
        fcolor = 255 '//red
        isbold = 0
        isitalic = 1
        isunderline = 1
        position = 2 'Top-Center
        MSetWatermark(id, "Watermark", "Arial", fsize, fcolor, isbold, isitalic, isunderline, position, 0, 0)

        pageCount = MGetCount(id)
        For i = 1 To pageCount
            pageWidth = MGetWidth(id, i)
            pageHeight = MGetHeight(id, i)

            MEncode(id, i)
            ProgressBar1.Value = Math.Round((i * 100) / pageCount)
        Next

        MFree(id)
        MsgBox("Convert finished!")

    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        Dim id As Integer
        Dim pageCount As Integer
        Dim i As Integer
        Dim fname As String

        Dim inFile As String = Application.StartupPath + "\test.pdf"
        Dim outPath As String = Application.StartupPath + "\output\"

        id = MLoad(inFile, "")
        Select Case id
            Case -1
                MsgBox("PDF file unexist or damaged!")
                Exit Sub
            Case -2
                MsgBox("PDF file is restricted!")
                Exit Sub
        End Select

        MSetParam(id, outPath, IMAGE_FORMAT_JP2, 24, 0, 75, 0, 0, 90, 800, 600, 120, 120)

        pageCount = MGetCount(id)
        For i = 1 To pageCount
            fname = "new_name" + Str(i)
            MEncodeEx(id, i, fname)
            ProgressBar1.Value = Math.Round((i * 100) / pageCount)
        Next

        MFree(id)
        MsgBox("Convert finished!")

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim txtmode As Integer
        Dim pagebreak As Integer
        Dim inFile As String = Application.StartupPath + "\test.pdf"
        Dim outFile As String = Application.StartupPath + "\output.txt"

        txtmode = 1 '1,2
        pagebreak = 1 '0,1
        MExtractText(inFile, "password", outFile, txtmode, pagebreak)

        MsgBox("Convert finished!")
    End Sub
End Class
